package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.model.VuforiaTarget;
import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.VuforiaImageInfo;
import com.izouma.awesomeadmin.service.VuforiaImageInfoService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * controller类
 */
@Controller
@RequestMapping("/vuforiaImageInfo")
public class VuforiaImageInfoController {

    @Autowired
    private VuforiaImageInfoService vuforiaImageInfoService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(VuforiaImageInfo record) {
        List<VuforiaImageInfo> pp = vuforiaImageInfoService.getVuforiaImageInfoList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getVuforiaImageInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getVuforiaImageInfo(@RequestParam(required = false, value = "id") String id) {
        VuforiaImageInfo data = vuforiaImageInfoService.getVuforiaImageInfoById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(VuforiaImageInfo record) {
        VuforiaImageInfo data = vuforiaImageInfoService.getVuforiaImageInfo(record);
        return new Result(true, data);
    }

    @RequestMapping(value = "/getTarget", method = RequestMethod.GET)
    @ResponseBody
    public Result getTarget(@RequestParam(required = false, value = "id") String id) {
        VuforiaTarget data = vuforiaImageInfoService.getVuforiaTarget(id);
        return new Result(true, data);
    }


    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, VuforiaImageInfo record) {
        Map<String, Object> result = new HashMap<>();

        List<VuforiaImageInfo> pp = vuforiaImageInfoService.getVuforiaImageInfoByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(VuforiaImageInfo record) {
        boolean num = vuforiaImageInfoService.createVuforiaImageInfo(record);
        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateVuforiaImageInfo(VuforiaImageInfo record) {
        boolean num = vuforiaImageInfoService.updateVuforiaImageInfo(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteVuforiaImageInfo(VuforiaImageInfo record) {

        return vuforiaImageInfoService.deleteVuforiaImageInfo(record);
    }

    /**
     * 导出Excel
     *
     * @param request
     * @param response
     * @param record
     * @throws Exception
     */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, VuforiaImageInfo record) throws Exception {

        List<VuforiaImageInfo> vuforiaImageInfos = vuforiaImageInfoService.getVuforiaImageInfoList(record);


        String sheetName = "vuforia_image_info";
        String titleName = "识别图信息数据表";
        String fileName = "识别图信息表";
        int columnNumber = 20;
        int[] columnWidth = {20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20};
        String[] columnName = {"ID", "删除标识", "更新时间", "更新人", "创建时间", "创建人", "所属图集ID", "识别图名称", "识别图类型ID", "区域标记编号", "所属地标ID", "AR内容组ID", "坐标X", "坐标Y", "坐标Z", "角度", "备注1", "备注2", "备注3", "识别图"};
        String[][] dataList = new String[vuforiaImageInfos.size()][20];

        for (int i = 0; i < vuforiaImageInfos.size(); i++) {

            dataList[i][0] = String.valueOf(vuforiaImageInfos.get(i).getId());
            dataList[i][1] = String.valueOf(vuforiaImageInfos.get(i).getDelFlag());
            dataList[i][2] = String.valueOf(vuforiaImageInfos.get(i).getUpdateTime());
            dataList[i][3] = String.valueOf(vuforiaImageInfos.get(i).getUpdateUser());
            dataList[i][4] = String.valueOf(vuforiaImageInfos.get(i).getCreateTime());
            dataList[i][5] = String.valueOf(vuforiaImageInfos.get(i).getCreateUser());
            dataList[i][6] = String.valueOf(vuforiaImageInfos.get(i).getVuforiaImageGroupId());
            dataList[i][7] = String.valueOf(vuforiaImageInfos.get(i).getName());
            dataList[i][8] = String.valueOf(vuforiaImageInfos.get(i).getVuforiaImageTypeId());
            dataList[i][9] = String.valueOf(vuforiaImageInfos.get(i).getAreaMarking());
            dataList[i][10] = String.valueOf(vuforiaImageInfos.get(i).getLandMarkId());
            dataList[i][11] = String.valueOf(vuforiaImageInfos.get(i).getArContentGroupId());
            dataList[i][12] = String.valueOf(vuforiaImageInfos.get(i).getPosX());
            dataList[i][13] = String.valueOf(vuforiaImageInfos.get(i).getPosY());
            dataList[i][14] = String.valueOf(vuforiaImageInfos.get(i).getPosZ());
            dataList[i][15] = String.valueOf(vuforiaImageInfos.get(i).getAngle());
            dataList[i][16] = String.valueOf(vuforiaImageInfos.get(i).getRemark1());
            dataList[i][17] = String.valueOf(vuforiaImageInfos.get(i).getRemark2());
            dataList[i][18] = String.valueOf(vuforiaImageInfos.get(i).getRemark3());
            dataList[i][19] = String.valueOf(vuforiaImageInfos.get(i).getVuforiaImage());
        }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
                columnNumber, columnWidth, columnName, dataList, response);


    }
}

